
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/minimization_hopcroft.hh>
%}
%define alg_minimization_hopcroft_interface(Automaton, GenAutomaton, Series, Exp, HList, Word)
static Automaton minimization_hopcroft(const Automaton& a) ;
static Automaton quotient(const Automaton& a) ;
%enddef
%define alg_minimization_hopcroft_interface_impl(Automaton, GenAutomaton, Series, Exp, HList, Word)
static  Automaton minimization_hopcroft(const Automaton& a) { return vcsn::minimization_hopcroft(*a); }
static  Automaton quotient(const Automaton& a) { return vcsn::quotient(*a); }
%enddef
%define alg_interface_minimization_hopcroft(Kind)
%{
struct Kind ##_alg_minimization_hopcroft {
alg_minimization_hopcroft_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>)
};
%}
%enddef
%define decl_alg_minimization_hopcroft(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_minimization_hopcroft {
alg_minimization_hopcroft_interface_impl(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>)
};
%}
struct Kind ##_alg_minimization_hopcroft {
alg_minimization_hopcroft_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t,
			std::list<int>,
			std::basic_string<Kind ##_types::Kind ##_letter_t>)
};
%enddef
