
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/normalized.hh>
%}
%define alg_normalized_interface(Automaton, GenAutomaton, Series, Exp, HList, Word)
static Automaton normalize(const Automaton& a) ;
static GenAutomaton normalize(const GenAutomaton& a) ;
static void normalize_here(Automaton& a) ;
static void normalize_here(GenAutomaton& a) ;
static bool is_normalized(const Automaton& a) ;
static bool is_normalized(const GenAutomaton& a) ;
static void union_of_normalized_here(Automaton& a1, const Automaton& a2) ;
static void union_of_normalized_here(GenAutomaton& a1, const GenAutomaton& a2) ;
static Automaton union_of_normalized(const Automaton& a1, const Automaton& a2) ;
static GenAutomaton union_of_normalized(const GenAutomaton& a1, const GenAutomaton& a2) ;
static void concatenate_of_normalized_here(Automaton& a1, const Automaton& a2) ;
static void concatenate_of_normalized_here(GenAutomaton& a1, const GenAutomaton& a2) ;
static Automaton concatenate_of_normalized(const Automaton& a1, const Automaton& a2) ;
static GenAutomaton concatenate_of_normalized(const GenAutomaton& a1, const GenAutomaton& a2) ;
static void star_of_normalized_here(Automaton& a) ;
static void star_of_normalized_here(GenAutomaton& a) ;
static Automaton star_of_normalized(const Automaton& a) ;
static GenAutomaton star_of_normalized(const GenAutomaton& a) ;
%enddef
%define alg_normalized_interface_impl(Automaton, GenAutomaton, Series, Exp, HList, Word)
static  Automaton normalize(const Automaton& a) { return vcsn::normalize(*a); }
static  GenAutomaton normalize(const GenAutomaton& a) { return vcsn::normalize(*a); }
static  void normalize_here(Automaton& a) { return vcsn::normalize_here(*a); }
static  void normalize_here(GenAutomaton& a) { return vcsn::normalize_here(*a); }
static  bool is_normalized(const Automaton& a) { return vcsn::is_normalized(*a); }
static  bool is_normalized(const GenAutomaton& a) { return vcsn::is_normalized(*a); }
static  void union_of_normalized_here(Automaton& a1, const Automaton& a2) { return vcsn::union_of_normalized_here(*a1, *a2); }
static  void union_of_normalized_here(GenAutomaton& a1, const GenAutomaton& a2) { return vcsn::union_of_normalized_here(*a1, *a2); }
static  Automaton union_of_normalized(const Automaton& a1, const Automaton& a2) { return vcsn::union_of_normalized(*a1, *a2); }
static  GenAutomaton union_of_normalized(const GenAutomaton& a1, const GenAutomaton& a2) { return vcsn::union_of_normalized(*a1, *a2); }
static  void concatenate_of_normalized_here(Automaton& a1, const Automaton& a2) { return vcsn::concatenate_of_normalized_here(*a1, *a2); }
static  void concatenate_of_normalized_here(GenAutomaton& a1, const GenAutomaton& a2) { return vcsn::concatenate_of_normalized_here(*a1, *a2); }
static  Automaton concatenate_of_normalized(const Automaton& a1, const Automaton& a2) { return vcsn::concatenate_of_normalized(*a1, *a2); }
static  GenAutomaton concatenate_of_normalized(const GenAutomaton& a1, const GenAutomaton& a2) { return vcsn::concatenate_of_normalized(*a1, *a2); }
static  void star_of_normalized_here(Automaton& a) { return vcsn::star_of_normalized_here(*a); }
static  void star_of_normalized_here(GenAutomaton& a) { return vcsn::star_of_normalized_here(*a); }
static  Automaton star_of_normalized(const Automaton& a) { return vcsn::star_of_normalized(*a); }
static  GenAutomaton star_of_normalized(const GenAutomaton& a) { return vcsn::star_of_normalized(*a); }
%enddef
%define alg_interface_normalized(Kind)
%{
struct Kind ##_alg_normalized {
alg_normalized_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>)
};
%}
%enddef
%define decl_alg_normalized(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_normalized {
alg_normalized_interface_impl(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>)
};
%}
struct Kind ##_alg_normalized {
alg_normalized_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t,
			std::list<int>,
			std::basic_string<Kind ##_types::Kind ##_letter_t>)
};
%enddef
