
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/sub_automaton.hh>
%}
%define alg_sub_automaton_interface(Automaton, GenAutomaton, Series, Exp, HList, Word)
static Automaton sub_automaton(const Automaton& a, const HList& s, bool c) ;
static GenAutomaton sub_automaton(const GenAutomaton& a, const HList& s, bool c) ;
static void sub_automaton_here(Automaton& a, const HList& s, bool c) ;
static void sub_automaton_here(GenAutomaton& a, const HList& s, bool c) ;
%enddef
%define alg_sub_automaton_interface_impl(Automaton, GenAutomaton, Series, Exp, HList, Word)
static  Automaton sub_automaton(const Automaton& a, const HList& s, bool c) { return vcsn::sub_automaton(*a, s, c); }
static  GenAutomaton sub_automaton(const GenAutomaton& a, const HList& s, bool c) { return vcsn::sub_automaton(*a, s, c); }
static  void sub_automaton_here(Automaton& a, const HList& s, bool c) { return vcsn::sub_automaton_here(*a, s, c); }
static  void sub_automaton_here(GenAutomaton& a, const HList& s, bool c) { return vcsn::sub_automaton_here(*a, s, c); }
%enddef
%define alg_interface_sub_automaton(Kind)
%{
struct Kind ##_alg_sub_automaton {
alg_sub_automaton_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>)
};
%}
%enddef
%define decl_alg_sub_automaton(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_sub_automaton {
alg_sub_automaton_interface_impl(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>)
};
%}
struct Kind ##_alg_sub_automaton {
alg_sub_automaton_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t,
			std::list<int>,
			std::basic_string<Kind ##_types::Kind ##_letter_t>)
};
%enddef
